﻿Public Class LatLonToEastNorth

    Shared WithEvents vcadd As New VCadd32.Automation

	Public Shared Function Run(ByVal str As String) As Integer

		Dim iLastEnt As Integer
		Dim iNewEnt As Integer
		Dim iCRSCode As Integer
		Dim iCount As Short
		Dim pt0 As New VCadd32.VCPoint2D
        Dim pt1 As New VCadd32.VCPoint2D
        Dim degOfLat As Double
		Dim textHt As Double

		iCRSCode = Val(str)	'	the CRS Code of the transformation
		degOfLat = 111.132 * 1000000.0 / 25.4	' degree of latitude in inches at 45 North (i.e., 111.132 kilometers)

        iLastEnt = vcadd.LastEntity()  ' last entity

		For iCurrEnt As Integer = 0 To iLastEnt	' loop to last entity

            vcadd.SetCurrentEntity(iCurrEnt)    ' set the current entity

            If Not vcadd.IsCurrentErased() Then ' process only non-erased entities

                vcadd.MatchCurrentEntity() ' match settings of the current entity

                If (vcadd.GetCurrentEntityKind() = 8) Then ' check for text
                    textHt = vcadd.GetTextHeight() * degOfLat ' convert text height from latitude to inches
                    vcadd.SetTextHeight(textHt)
                End If

                vcadd.Duplicate(iCurrEnt) ' make a copy of the original
                vcadd.SetCurrentErased()   ' erase the original
                iNewEnt = vcadd.LastEntity()   ' get the new entity

                iCount = vcadd.GetCurrentEntityPointCount() ' point count of the entity

                For iIndex As Short = 0 To (iCount - 1) ' loop through all points

                    vcadd.SetCurrentEntity(iCurrEnt)

                    pt0 = vcadd.GetCurrentEntityPoint(iIndex)  ' data assumed to be in degrees of lat/lon
                    pt0.X = pt0.X * 3.1415926535897931 / 180.0 ' convert degrees to radians
                    pt0.Y = pt0.Y * 3.1415926535897931 / 180.0

                    pt1 = vcadd.GetEastingNorthing(iCRSCode, pt0)  ' convert to easting-northing

                    vcadd.SetCurrentEntity(iNewEnt)
                    vcadd.SetCurrentEntityPoint(iIndex, pt1)   ' change data to easting-northing
                Next

            End If
        Next

        vcadd.ZoomAll() ' redraw

		Return (True)
	End Function

End Class
