﻿' VB.NET to Parse the Database
'   lines starting with an apostrophe are comments
Public Class ParseDBase

    ' create Visual CADD object
    Shared WithEvents vcadd As New VCadd32.Automation

    Public Shared Function Run(ByVal str As String) As Integer

        '   used for messages
        Dim sz As String

        '   setup some counters
        Dim iErasedCount As Integer = 0
        Dim iUnerasedCount As Integer = 0
        
        '   parse through the entire database:
        '   start at the first entity
        vcadd.FirstEntity()

        '   loop through entities
        Do While (vcadd.GetErrorCode() = 0)
            '   VCFirstEntity() and VCNextEntity() move through the 
            '   database and make each successive entity the current 
            '   entity.  For example, we will process each current 
            '   entity to count the erased and un-erased entities.

            If (vcadd.IsCurrentErased() = 0) Then
                iUnerasedCount = iUnerasedCount + 1
            Else
                iErasedCount = iErasedCount + 1
            End If

            vcadd.NextEntity()

        Loop

        sz = "Erased count: " + CStr(iErasedCount) + vbLf
        sz = sz + "Un-Erased count: " + CStr(iUnerasedCount)

        MsgBox(sz, MsgBoxStyle.Information, "API Help Sample")

        ' return
        Return (True)

    End Function

End Class
