﻿' VB.NET to Check Version
'   lines starting with an apostrophe are comments
Public Class Version

    ' create Visual CADD object
    Shared WithEvents vcadd As New VCadd32.Automation

    Public Shared Function Run(ByVal str As String) As Integer

        '   used for messages
        Dim sz As String

        '   Check the version numbers:
        '       If your application requires a certain Visual CADD 
        '       version, use the following code to retrieve the 
        '       version numbers for error checking:

        Dim iMajor As Short
        Dim iMinor As Short
        Dim iDot As Short
        Dim iInternal As Short
        Dim iFull As Long
        Dim iTarget As Long

        '   get the version numbers
        iMajor = vcadd.GetMajorVersion()
        iMinor = vcadd.GetMinorVersion()
        iDot = vcadd.GetMinorDotVersion()
        iInternal = vcadd.GetMinorInternalVersion()

        sz = "Visual CADD Version: "
        sz = sz + CStr(iMajor)
        sz = sz + "." + CStr(iMinor)
        sz = sz + "." + CStr(iDot)
        sz = sz + "." + CStr(iInternal)

        '   get the full version packed as major/minor/dot/internal
        iFull = vcadd.GetFullVersion()
        iTarget = &H7000000  '   packed 7.0.0.0

        If (iFull >= iTarget) Then
            sz = sz + vbLf + "Version is v7.0.0 or higher"
            MsgBox(sz, MsgBoxStyle.Information, "API Help Sample")
        Else
            sz = sz + vbLf + "Version is less than v7.0.0"
            MsgBox(sz, MsgBoxStyle.Exclamation, "API Help Sample")

            '   Optional - stop tool from running
        End If

        ' return
        Return (True)

    End Function

End Class
